// First algorithm

Formulation {
  { Name DDM_1; Type FemEquation;
    Quantity{
			For ii In {0:#myD()-1}
				i = myD(ii);
				{ Name u~{i} ; Type Local; NameOfSpace H_grad~{i};}
			EndFor
			For k In {0:#ListGammaExt()-1}
				{ Name phi~{k} ; Type Local; NameOfSpace H_phi~{k};}
			EndFor
		}
    Equation{
    	For ii In {0:#myD()-1}
				i = myD(ii);
				// PDE on u_i
				//Helmholtz equation
				Galerkin{[Dof{Grad u~{i}}, {Grad u~{i}}];
					In Omega~{i}; Jacobian JVol; Integration I1;}
				Galerkin{[-kap^2*Dof{u~{i}}, {u~{i}}];
					In Omega~{i}; Jacobian JVol; Integration I1;}
				// dni ui -i*kap ui = gij on Sigma ij
				For jj In {0:#myD~{i}()-1}
					j = myD~{i}(jj);
					Galerkin{[-I[]*kap*Dof{u~{i}}, {u~{i}}];
							In Sigma~{i}~{j}; Jacobian JSur; Integration I1;}
					Galerkin{[$TCSource?-g~{i}~{j}[]:0., {u~{i}}];
						In Sigma~{i}~{j}; Jacobian JSur; Integration I1;}
				EndFor
				If(ABC_ORDER==0)
					Galerkin{[-I[]*kap*Dof{u~{i}}, {u~{i}}];
						In dOmegaExt~{i}; Jacobian JSur; Integration I1;}
				Else
					// dn u_i = i*omega*phi_k on Gamma_i^k
					For kk In {0:#ListGammaExt~{i}()-1}
						k=ListGammaExt~{i}(kk);
						Galerkin{[-I[]*kap*Dof{phi~{k}}, {u~{i}}];
							In GammaExt~{i}~{k}; Jacobian JSur; Integration I1;}
					EndFor
				EndIf
			EndFor

			// Operator T
			If(ABC_ORDER == 2)
				For ii In {0:#myD()-1}
					i = myD(ii);
					For kk In {0:#ListGammaExt~{i}()-1}
						k = ListGammaExt~{i}(kk);
						Galerkin{[-Dof{u~{i}}, {phi~{k}}];
							In GammaExt~{i}~{k}; Jacobian JSur; Integration I1;}
					EndFor
				EndFor
				For kk In {0:#ListGammaExt()-1}
					k = ListGammaExt(kk);
					Galerkin{[Dof{phi~{k}}, {phi~{k}}];
						In GammaExt~{k}; Jacobian JSur; Integration I1;}
					Galerkin{[1/(2*kap^2)*Dof{d phi~{k}}, {d phi~{k}}];
						In GammaExt~{k}; Jacobian JSur; Integration I1;}
					// Corner correction
					If(CORNER_CONDITION == 2)
						For index In {0:#ListdGammaExt~{k}()-1}
							// Loop on end-point
							l=ListdGammaExt~{k}(index); // Index of ajacent segment
							Galerkin{[-I[]/(4*kap)*(Cos[theta]/Cos[theta/2]+Cos[theta/2])*Dof{phi~{k}}, {phi~{k}}];
								In Apt~{k}~{l}; Jacobian JLin; Integration I1;}
							Galerkin{[-I[]/(4*kap)*(-Cos[theta]/Cos[theta/2]+Cos[theta/2])*Dof{phi~{l}}, {phi~{k}}];
								In Apt~{k}~{l}; Jacobian JLin; Integration I1;}
						EndFor
					EndIf
				EndFor
			EndIf
    }
  }

  // Equation to compute the transmitted data g_{ji} that is sent to Omega_j
  For ii In {0:#myD()-1}
    i = myD(ii);
    For jj In {0:#myD~{i}()-1}
    	j = myD~{i}(jj);
      	{ Name G~{j}~{i}; Type FemEquation;
	        Quantity{
						{ Name u~{i} ; Type Local; NameOfSpace H_grad~{i};}
						{ Name g~{j}~{i} ; Type Local; NameOfSpace H_g~{j}~{i};}
					}
			Equation{
				Galerkin{[Dof{g~{j}~{i}},{g~{j}~{i}}];
					In Sigma~{j}~{i}; Jacobian JSur; Integration I1;}
				Galerkin{[$TCSource?+g~{i}~{j}[]:0.,{g~{j}~{i}}];
	    		 In Sigma~{j}~{i}; Jacobian JSur; Integration I1;}
				Galerkin{[2*I[]*kap*{u~{i}},{g~{j}~{i}}];
	    		 In Sigma~{j}~{i}; Jacobian JSur; Integration I1;}
				}
			}
    EndFor
  EndFor
}

Resolution{
  {Name DDM_1;
    System{
      {Name DDM_1; NameOfFormulation DDM_1; Type Complex; }
      For ii In {0:#myD()-1}
				i = myD(ii);
				For jj In {0:#myD~{i}()-1}
	  			j = myD~{i}(jj);
	  			{Name G~{j}~{i}; NameOfFormulation G~{j}~{i}; Type Complex; }
				EndFor
      EndFor
    }
    Operation{
			CreateDir[ABC_DIR];
      // Initialisation
      Evaluate[$PhysicalSource = 1];
      Evaluate[$TCSource = 0];
      UpdateConstraint[DDM_1, dOmegaInt, Assign];
      Generate[DDM_1];
      Solve[DDM_1];
      For ii In {0:#myD()-1}
				i = myD(ii);
				For jj In {0:#myD~{i}()-1}
	  			j = myD~{i}(jj);
	  			Generate[G~{j}~{i}];
	  			Solve[G~{j}~{i}];
					PostOperation[G~{j}~{i}];
					//Save RHS if jacobi
					If(StrCmp(SOLVER, "jacobi") == 0)
						PostOperation[B~{j}~{i}];
					EndIf
				EndFor
      EndFor
      Evaluate[$PhysicalSource = 0];
      Evaluate[$TCSource = 1];
			UpdateConstraint[DDM_1, dOmegaInt, Assign];
			Evaluate[$ItCount = 0];
      IterativeLinearSolver["I-A",SOLVER, TOL, MAXIT, RESTART, {ListOfFields_g()}, {}, {}]
      {
				// Compute local solutions
				GenerateRHSGroup[DDM_1, Region[{Sigma, TrdOmegaInt, GammaExt, dGammaExt}]];
				SolveAgain[DDM_1];
				For ii In {0:#myD()-1}
				  i = myD(ii);
				  For jj In {0:#myD~{i}()-1}
				    j = myD~{i}(jj);
				    GenerateRHSGroup[G~{j}~{i}, Region[{Sigma~{i}}]];
				    SolveAgain[G~{j}~{i}];
				  EndFor
				EndFor
				// Update data to be exchanged
				For ii In {0:#myD()-1}
					i = myD(ii);
					For jj In {0:#myD~{i}()-1}
						j = myD~{i}(jj);
						If(StrCmp(SOLVER, "jacobi") == 0)
							PostOperation[NormL2G~{j}~{i}]; // Compute difference between new and old g_ji
						EndIf
						PostOperation[G~{j}~{i}];
					EndFor
				EndFor

				Evaluate[$ItCount = $ItCount+1];
      }
      //Compute global solution
      Evaluate[$PhysicalSource = 1];
      Evaluate[$TCSource = 1];
      UpdateConstraint[DDM_1, dOmegaInt, Assign];
      GenerateRHSGroup[DDM_1, Region[{Sigma, TrdOmegaInt, GammaExt, dGammaExt}]];
      SolveAgain[DDM_1];
      PostOperation[DDM];
    }
  }
}
